#-*-coding:utf-8-*-

# class build(object):
#     def __init__(self):
#         super(build, self).__init__()

# import logging

# def use_logging(level):
#     def decorator(func):
#         def wrapper(*args, **kwargs):
#             if level == "warn":
#                 logging.warn("%s is running" % func.__name__)
#             elif level == "info":
#                 logging.info("%s is running" % func.__name__)
#             return func(*args)
#         return wrapper

#     return decorator

# @use_logging(level="warn")
# def foo(name='foo'):
#     print("i am %s" % name)

# foo()


# def main():
#     parser = argparse.ArgumentParser(prog='cmd')

#     sub_parser = parser.add_subparsers(title='subcommands',
#                                     description='valid subcommands',
#                                     help='config subscommand help')

#     add_parser = sub_parser.add_parser('add',help='add user config')
#     add_parser.add_argument('--name', required=True, help='user name')
#     add_parser.add_argument('--addr', required=False, help='user address')
#     add_parser.add_argument('--phone', required=False, help='phone number')
#     add_parser.set_defaults(func=add_fn)

#     delete_parser = sub_parser.add_parser('delete', help='delete user config')
#     delete_parser.add_argument('--name', required=True, help='user name')
#     delete_parser.set_defaults(func=delete_fn)

#     show_parser = sub_parser.add_parser('show', help='show user config')
#     show_parser.set_defaults(func=show_fn)
    
#     args = parser.parse_args()
#     args.func(args)

from .util import *
import shutil,json

class Build:
    def __init__(self):
        print('')

    def buildTask(self,dir,out,biz):
        print('\n')
        
        #env
        setupEnv()
        print('\r\n')
        cui.w('BUILD TASK START....')

        entry = dir
        bizCode = biz
        outPath = out
        outPathZip = os.path.join(outPath,'zip')

        if os.path.exists(outPath):
            shutil.rmtree(outPath)
    
        cui.i('outPath is {0}'.format(outPath))
        cui.i('outPathZip is {0}'.format(outPathZip))
    
        buildCommand = "accore build -p {0} -d {1}".format(entry,'./temp')
        buildEnd = os.system(buildCommand)
        if buildEnd == 0:
            #mk output dir 
            if not os.path.exists(outPath) :
                os.makedirs(outPath)
                os.makedirs(outPathZip)
            #process bin
            binResult = getAllFtFiles('./temp','.bin')
            for binPath in binResult:
                filePath,filename=os.path.split(binPath)
                #read json
                filename,donotcare = os.path.splitext(filename)
                jsonPath = os.path.join(filePath,filename+'.json')
            
                with open(jsonPath,'r') as jsonFile:
                    jsonFileContent = jsonFile.read()

                jsonDic = json.loads(jsonFileContent)
                metaString = jsonDic['meta']
                meta = json.loads(metaString)
                version = meta['version']
                templateId = meta['name']
                # build template
                renamePath = "{0}@{1}@{2}.template".format(bizCode,templateId,version)
                os.rename(binPath,outPath + '/' + renamePath)
                cui.s(outPath + '/' + renamePath + '   🦶🦶🦶')
                # build zst
                zstdPath= os.path.join(filePath,filename+'.zst')
                renamePath = "{0}@{1}@{2}.zip".format(bizCode,templateId,version)
                os.rename(zstdPath,outPathZip + '/'+ renamePath)
                # cui.s(outPathZip + '/' + renamePath + ' ....')
    
        shutil.rmtree('./temp')
        cui.w('BUILD TASK  END....')
